%% visualize results

% close(100)

if strcmp(method, 'pdhg') || strcmp(method, 'all')
figure(11)
u = reshape(u_pdhg,n,k);
[~, classes] = max(u, [], 2);
im_result = reshape(C(classes, :), [ny nx 3]);
subplot(121)
imagesc(img)
axis equal off
title('input image')
subplot(122)
imagesc(im_result)
axis equal off
title('segmentation via PDHG')

figure(14)
plot(primal_ener_pdhg)
hold on;
title('primal energy')

figure(15)
semilogy(primal_ener_pdhg+dual_ener_pdhg)
hold on;
title('duality gap')
end


if strcmp(method, 'drs') || strcmp(method, 'all')
figure(12)
u = reshape(u_drs,n,k);
[~, classes] = max(u, [], 2);
im_result = reshape(C(classes, :), [ny nx 3]);
subplot(121)
imagesc(img)
axis equal off
title('input image')
subplot(122)
imagesc(im_result)
axis equal off
title('segmentation via DRS')

figure(14)
plot(primal_ener_drs)
hold on;
title('primal energy')

figure(15)
semilogy(primal_ener_drs+dual_ener_drs)
hold on;
title('duality gap')
end


if strcmp(method, 'admm') || strcmp(method, 'all')
figure(13)
u = reshape(u_admm,n,k);
[~, classes] = max(u, [], 2);
im_result = reshape(C(classes, :), [ny nx 3]);
subplot(121)
imagesc(img)
axis equal off
title('input image')
subplot(122)
imagesc(im_result)
axis equal off
title('segmentation via ADMM')

figure(14)
plot(primal_ener_admm)
hold on;
title('primal energy')

figure(15)
semilogy(primal_ener_admm+dual_ener_admm)
hold on;
title('duality gap')
end

if strcmp(method, 'all')
    figure(14)
    legend('PDHG', 'DRS', 'ADMM')
    
    figure(15)
    legend('PDHG', 'DRS', 'ADMM')
    
end

